تخطَّ إلى المحتوى
مفتاحانTwo Keys
القائمة

كيف يجد هاتفان ومختبر جيناً مشتركاً دون كشف أي شيء آخر

يشغّل هذا البروتوكول الحقيقي في متصفحك بمفتاح مختبر مؤقت. كل قيمة أدناه هي القيمة الفعلية.

Loading… / جارٍ التحميل…

ما يضمنه التصميم

لا جينات مزوّرة

لا يصنع الرمز إلا المختبر، فلا يستطيع الشريك إضافة جينات لا يحملها للتجسس على نتائج الآخر. هذا هو PSI المخوَّل (De Cristofaro وTsudik، 2009)، والمختبر هو الجهة الموثوقة التي تصدر الرموز.

يؤكد الطرفان هوية من انضم

يُحجز كل مقعد مرة واحدة فقط. يرى صاحب الرابط اسم من انضم أولاً ويؤكده، وعندها فقط يرى المنضم صاحب الرابط ويؤكده بدوره. ولا يصدر المختبر أي رمز حتى يوافق الاثنان، فمن صوّر الرمز لا يعرف اسماً ولا نتيجة.

إعادة قفل أمينة، مُثبتة

يثبت كل هاتف للمختبر أن قفله الأول استخدم سراً واحداً على الرموز التي أُعطيت له بالضبط، فيوقّع المختبر ذلك القفل ويتحقق الشريك من التوقيع. ثم تصل كل إعادة قفل مع إثبات قصير (Chaum–Pedersen مجمّع، كما في RFC 9497) أن السر نفسه استُخدم. ويُرفض الهاتف الغاش في أي من الخطوتين.

لا عدّ

يعطي المختبر كل هاتف 64 رمزاً بالضبط، تختبئ الحقيقية بين رموز تمويهية بترتيب يحدده مفتاح المختبر، والقائمة نفسها في كل مرة، فلا يعرف الشريك ولا من يحمل الهاتف عدد النتائج.

مطابقة تراعي الشدة

تصنّف الوسوم الجين المشترك كتطابق كامل أو أخف (تغيّر أخف لدى أحدكما) أو منخفض الأثر (تغيّران أخفان). ومقابل ذلك: في الجين المشترك يعرف شريكك إن كان تغيّرك هو الأخف، لأن الاحتمال يعتمد عليه.

نتائج كروموسوم X تصل إلى صاحبها

تهم نتيجة الكروموسوم X أياً كان الشريك (أبناء المرأة، وصحة الرجل وبناته)، لذا تصل إلى صاحبها كنتيجة شخصية، لا عبر الاقتران وحده.

من قد يعرف ماذا

نموذج تهديد، صف لكل طرف. وصيغت كل عبارة بحيث يمكن التحقق منها في الشيفرة والاختبارات في صفحة الإثبات.

منيمكنه أن يعرفلا يستطيعيُفرض عبر
شريككالجينات التي تحملانها معاً وهل التغيّر هو الأخف (وهذا هو الغرض)، وأنك شاركت.أي جين تحمله وحدك، أو عدد جيناتك، إلا إذا اخترتما معاً رؤية كل شيء.رموز لا يصنعها إلا المختبر، 64 لكل هاتف مع رموز تمويهية، وإثبات لإعادة القفل
من يرى رمز الاقترانلا شيء، ولا حتى اسم صاحب الرمز، إلا إذا أكده صاحب الرمز بالاسم، ولا هل تتطابقان أو كيف. فالرمز يفتح الطبقة الخارجية لدى الوسيط، لكن القوائم التي قد تكشف التطابق مختومة مرة ثانية بمفتاح لا يصنعه إلا الهاتفان.حجز مقعد خفية: فلا يصدر المختبر أي رمز حتى يؤكد الطرفان بعضهما.مقاعد ذرية، ويؤكد صاحب الرابط أولاً، ولا رموز إلا بعد تأكيد الطرفين، والقوائم ذات القفلين مختومة بمفتاح من سرَّي الهاتفين
هاتف معدَّللا أكثر من الهاتف الأمين، ويمكنه رفض الإكمال.تزوير تطابق أو إخفاؤه أو عرض نتيجة خاطئة على الشريك: فقفله الأول يشهد عليه المختبر، وإعادة القفل مُثبتة، ولا يسمّي المختبر جيناً إلا إذا اتفقت مقارنتا الهاتفين مع سجلاته، وإلا فلا يُسمّى شيء.قفل أول يشهد عليه المختبر، وإثبات لإعادة القفل، وتسمية عند الاتفاق فقط
الوسيطأن جهازين تبادلا بضعة كيلوبايتات، ومتى.قراءة أي شيء: فالرسائل مشفّرة بمفتاح لا يصل إلى أي خادم.AES-GCM بمفتاح في جزء الرابط بعد #، وطبقة ثانية لا يفتحها إلا الهاتفان، وخانات تُكتب مرة ولا يكتب فيها إلا هاتف يملك الرابط (معرّف صندوق الرسائل بصمة لمفتاح كتابة مشتق من الرابط)، ولا تُقرأ بعد 10 دقائق وتحذفها قاعدة البيانات خلال 48 ساعة
المختبر (مختبر واحد، اليوم)أن هذين الشخصين اقترنا، والتطابق الذي يسمّيه: فهو يحسب التطابق من سجلاته كما يستطيع اليوم، إذ يملك النتيجتين أصلاً. ويُحفظ من اقترن بمن، والجينات التي سمّاها، يوماً واحداً. وإذا حجز أحدهما موعداً مع مرشد وراثي، تحتفظ حالته برمز مشفّر بمفتاح للاقتران (لا الاقتران نفسه) طوال مدة الحالة، ليعرف المكتب هل حجز الشريك أيضاً؛ ويمحوه سحب الموافقة.لا شيء جديد عن أي منهما، فهو موثوق كما هو اليوم. وفي هذا العرض يعمل المختبر والوسيط على خادم واحد، وفي الإنتاج يشغّلهما طرفان منفصلان.الثقة والتدقيق والقانون (المرسوم بقانون 49/2023)
المرشد الوراثيما اختاره الشخص عند الحجز فقط، والجينات المشتركة هي فقط ما سمّاه المختبر بعد اتفاق مقارنتي الهاتفين، فالحجز قبل ذلك لا يسمّي شيئاً. وتعرض القائمة الأسماء، وهل الحالة عاجلة، وهل هي متأخرة أو مستحقة اليوم أو لاحقاً (لا الموعد الدقيق الذي قد يلمّح إلى حمل)، والأعداد فقط؛ ولا يظهر الموعد الدقيق، ولا أن الشريك حجز أيضاً، إلا في الحالة المفتوحة. وتُسجَّل كل حالة تُفتح وكل قراءة للقائمة.رؤية نتائج الشريك الخاصة، أو ما شُورك بعد سحب الموافقة. في العرض: رمز مرور واحد مع اسم يُختار، وحساب للمحكّمين دون رمز؛ وفي الإنتاج: دخول لكل طبيب.موافقة مفصّلة، وسلاسل تدقيق بمفتاح وختم تغطي محتوى كل حالة وقراءات القائمة (تُثبَّت خارج قاعدة البيانات في الإنتاج)، وقائمة بملخصات فقط، وقفل الدخول لعنوان واحد بعد 20 محاولة فاشلة في الساعة، ولا يُقفل للجميع أبداً
محلل في الجهة الصحيةأعداد إجمالية أسبوعية مع ضجيج عشوائي: يُحتسب أول حجز وأول إعادة شرح لكل شخص مرة واحدة في السنة، وخمس من ملاحظاته العائلية على الأكثر في السنة؛ وتُحجب المجموعات الأصغر من 5.أي فرد، أو أي زوجين يتشاركان جيناً، أو أي قرار زواج أو حمل.ضجيج لابلاس متقطع دقيق من مولّد بمفتاح (إعادة الحساب تعطي الأرقام نفسها)، وعلامات لكل شخص باسم مستعار يتغيّر مفتاحه كل سنة وتُحذف بنهايتها، وإصدار واحد لكل أسبوع في سجل لا يُضاف إليه إلا، وε ≤ 3 لكل شخص في السنة
أي شخص آخر على الإنترنتفي هذا العرض يمكن لأي شخص الدخول باسم أي شخص افتراضي، ولا يوجد أشخاص حقيقيون. وفي الإنتاج: لا شيء عن أي شخص.في الإنتاج: الحصول على رموز أو نتائج دون UAE PASS، أو الانضمام إلى اقتران غيره دون تأكيده.هوية موقّعة (UAE PASS في الإنتاج)، ومقاعد ذرية، وتأكيد بالاسم، وحدود للطلبات

لماذا المطابقة الخاصة إن كان المختبر يملك النتيجتين؟

في أبوظبي اليوم يفحص مختبر واحد الشريكين، فالمختبر موثوق، ويحمي البروتوكول كل شخص من شريكه ومن كل من في الطريق. ويزداد أهمية حيث لا تملك جهة واحدة النتيجتين:

  • شريكان فُحصا لدى جهات مختلفة: أبوظبي ودبي، أو البرنامج الاتحادي، أو مختبر في الخارج لزوج غير إماراتي. يصدر كل مختبر رموزاً لمريضه فقط، ولا يملك أحد النتيجتين أبداً.
  • بطاقة نتائج قابلة لإعادة الاستخدام: فحص مرة واحدة ثم مقارنة لاحقاً مع شريك مستقبلي دون إعادة الفحص.
  • عيادات خاصة وعيادات أطفال الأنابيب تقارن متبرعين أو شركاء عبر مختبرات مختلفة.

تتطلب المطابقة بين المختبرات أن تتفق على نظام رموز واحد (مفتاح رموز مشترك أو محسوب بشكل مشترك). وهذا مصمَّم له، لكنه غير مبني بعد.

ما لا يفعله

  • التطابق تطابق: إن تشاركتما جيناً فسيعرف شريكك أنك تحمله. وهذه هي المعلومة التي يحتاجها الزوجان.
  • يطابق الجينات لا المتغيرات بدقة. وحيث يهم الزوج الدقيق (أليلات CAH غير التقليدية، أو ألفا غلوبين على الكروموسوم نفسه أو المقابل، أو HbS مع HbC) تقول النتيجة ذلك ويؤكده المرشد الوراثي.
  • حجز المرشد الوراثي يحفظ على الخادم ما تختاره بالضبط، ويمكنك سحبه.
  • إنه نموذج أولي ولم يُدقّق بشكل مستقل. ويسبق أي تجربة تدقيقُ تشفير واختبار اختراق.

حين فحص الشريكين مختبران مختلفان

في العرض الحالي يحتفظ مختبر واحد بالنتيجتين، كما في أبوظبي اليوم. أما بين مختبرين (المرحلة الثانية) فيتغير التصميم في ثلاثة مواضع، ونذكر ما يُفقد:

  1. مفتاح الرموز: يصدر كل مختبر رموز مريضه فقط، بمفتاح يحسبه المختبران معاً (دالة عشوائية زائفة عمياء لطرفين أو مفتاح عتبي)، فلا يستطيع أي مختبر وحده صنع رموز الآخر.
  2. التسمية: يسمّي كل مختبر الرموز المتطابقة لمريضه فقط (وتحمل التسميات الدرجة والنمط الجيني لألفا)، ويجمع الهاتفان النصفين.
  3. ما يُفقد: لا يستطيع مختبر واحد إعادة حساب التقاطع كاملاً للتحقق من ادعاءي الهاتفين. يتحقق كل مختبر من ادعاء مريضه مقابل سجلاته؛ والهاتف الذي يكذب في نصف شريكه لا يضلّل إلا نفسه، ويؤكد المرشد أي جين مسمّى قبل أي خطوة سريرية.

هذا تصميم للمرحلة الثانية، ولم يُبنَ بعد؛ والمراجعة التشفيرية المستقلة شرط في المرحلة صفر.

من الداخل

الزمرة
ristretto255 (RFC 9496), @noble/curves
الرموز
hash-to-group (RFC 9380) of HMAC-SHA-256(session key, session ‖ role tag ‖ gene); session key = HMAC-SHA-256(lab token key, session ‖ server nonce)
المطابقة
PSI بطريقة ديفي-هيلمان؛ 64 رمزاً لكل مقعد بترتيب يحدده مفتاح المختبر، ثابتة في كل طلب؛ وخلط عشوائي آمن على الهاتف
الإثباتات
القفل الأول: إثبات DLEQ للمختبر الذي يوقّعه (Ed25519) للشريك. وإعادة القفل: إثبات DLEQ مجمّع بطريقة Chaum–Pedersen (على نمط RFC 9497)
النتيجة
يبلغ كل هاتف عن رموزه المتطابقة؛ ولا يسمّي المختبر الجينات المشتركة إلا إذا ساوى البلاغان حسابه، ولا يسمّي شيئاً غير ذلك
الوسيط
AES-GCM بمفتاح مشتق عبر HKDF من سر الرابط؛ وفي داخله تُختم القوائم ذات القفلين مرة ثانية بمفتاح HKDF(G·a·b، الجلسة) الذي لا يحسبه إلا الهاتفان؛ خانات تُكتب مرة واحدة؛ لا تُقرأ بعد 10 دقائق وتُحذف خلال 48 ساعة
الاختبارات
انظر الإثبات